#include "squidwall.h"

/* buffers for clamd command connection */
static char clamd_iBUF[BUFSIZE]; buffer clamd_in;
static char clamd_oBUF[BUFSIZE]; buffer clamd_out;

/* buffers for clamd data/stream connection */
static char clams_oBUF[BUFSIZE]; buffer clams_out;

/* buffers for proxy connection */
static char proxy_iBUF[BUFSIZE]; buffer proxy_in;
static char proxy_oBUF[BUFSIZE]; buffer proxy_out;

stralloc virus;
stralloc clamav;
stralloc filter;
stralloc pfilter_matches;

int cfilter_todo;
int pfilter_todo, pfilter_current;

#define SCAN_UNKNOWN 1
#define SCAN_YES     2
#define SCAN_NO      3
static int check_cont_hdr(array *a, char *line)
{
	struct squidwall_regex *regex;
	struct named_regex *nr;
	int i, j;

	/* last http header was send, no scanning of this content is wanted! */
	if (str_len(line) == 0) {
		debug_s3(DEBUG_CHECK_CONT,
			"check_hdr: SCAN_NO @ line(", line, ")\n");
		return SCAN_NO;
	}

	for (i=0; i < array_length(a, sizeof(struct squidwall_regex)); i++) {
		regex = array_get(a, sizeof(struct squidwall_regex), i);
		for (j=0; j < array_length(&regex->regex, sizeof(struct named_regex)); j++) {
			nr = array_get(&regex->regex, sizeof(struct named_regex), j);
			if (regexec(&nr->r, line, 0, 0, nr->eflags) == 0) {
				debug_s3(DEBUG_CHECK_CONT,
					"check_hdr: SCAN_YES @ line(", line, ")\n");
				return SCAN_YES;
			}
		}
	}

	debug_s3(DEBUG_CHECK_CONT,
		"check_hdr: SCAN_UNKNOWN @ line(", line, ")\n");

	return SCAN_UNKNOWN;
}

static int check_cont_line(char *line)
{
	struct squidwall_string *string;
	struct squidwall_phrase *phrase;
	struct squidwall_regex *regex;
	struct named_regex *nr;
	struct list_head *l;
	char *file, *str, num[FMT_ULONG];
	unsigned int j, k, k2, *val;

	if (cfilter_todo == SCAN_YES)
	if (cfilter_host && cfilter_host->len)
	for (j=0; j < cfilter_host->len; j += str_len(cfilter_host->s+j)+1)
	list_for_each(l, &cfilter) {
		string = list_entry(l, struct squidwall_string, list);
		file = cfilter_host->s+j;
		if (str_equal(file, string->filename.s))
		for (k=0; k < string->strings.len;
				k += str_len(string->strings.s+k)+1) {
			str = string->strings.s+k;
			if (case_strstr(line, str)) {
				if (!stralloc_copy(&filter, &string->filename)) die_nomem();
				if (!stralloc_cats(&filter, " / ")) die_nomem();
				if (!stralloc_cats(&filter, str)) die_nomem();
				filter.s[filter.len]=0;
				redir_site(REDIR_TYPE_CONT);
				return ACL_DENY;
			}
		}
	}

	if (cfilter_todo == SCAN_YES)
	if (cfilter_user && cfilter_user->len)
	for (j=0; j < cfilter_user->len; j += str_len(cfilter_user->s+j)+1)
	list_for_each(l, &cfilter) {
		string = list_entry(l, struct squidwall_string, list);
		file = cfilter_user->s+j;
		if (str_equal(file, string->filename.s))
		for (k=0; k < string->strings.len;
				k += str_len(string->strings.s+k)+1) {
			str = string->strings.s+k;
			if (case_strstr(line, str)) {
				if(!stralloc_copy(&filter, &string->filename)) die_nomem();
				if(!stralloc_cats(&filter, " / ")) die_nomem();
				if(!stralloc_cats(&filter, str)) die_nomem();
				filter.s[filter.len]=0;
				redir_site(REDIR_TYPE_CONT);
				return ACL_DENY;
			}
		}
	}

	if (pfilter_todo == SCAN_YES)
	if (pfilter_user && pfilter_user->len)
	for (j=0; j < pfilter_user->len; j += str_len(pfilter_user->s+j)+1)
	list_for_each(l, &pfilter) {
		phrase = list_entry(l, struct squidwall_phrase, list);
		file = pfilter_user->s+j;
		if (str_equal(file, phrase->filename.s))
		for (k=0, k2=0; k < phrase->strings.len;
				k += str_len(phrase->strings.s+k)+1, k2++) {
			str = phrase->strings.s+k;
			val = array_get(&phrase->points, sizeof(unsigned int), k2);
			if (case_strstr(line, str)) {
				num[fmt_ulong(num, *val)]=0;
				if (!stralloc_cat(&pfilter_matches, &phrase->filename)) die_nomem();
				if (!stralloc_cats(&pfilter_matches, " (")) die_nomem();
				if (!stralloc_cats(&pfilter_matches, str)) die_nomem();
				if (!stralloc_cats(&pfilter_matches, " / ")) die_nomem();
				if (!stralloc_cats(&pfilter_matches, num)) die_nomem();
				if (!stralloc_cats(&pfilter_matches, ")<br>")) die_nomem();
				pfilter_current += *val;
				if (pfilter_current >= pfilter_max) {
					if (!stralloc_copy(&filter, &pfilter_matches)) die_nomem();
					redir_site(REDIR_TYPE_CONT);
					filter.s[filter.len]=0;
					return ACL_DENY;
				}
			}
		}
	}

	if (pfilter_todo == SCAN_YES)
	if (pfilter_host && pfilter_host->len)
	for (j=0; j < pfilter_host->len; j += str_len(pfilter_host->s+j)+1)
	list_for_each(l, &pfilter) {
		phrase = list_entry(l, struct squidwall_phrase, list);
		file = pfilter_host->s+j;
		if (str_equal(file, phrase->filename.s))
		for (k=0, k2=0; k < phrase->strings.len;
				k += str_len(phrase->strings.s+k)+1, k2++) {
			str = phrase->strings.s+k;
			val = array_get(&phrase->points, sizeof(unsigned int), k2);
			if (case_strstr(line, str)) {
				num[fmt_ulong(num, *val)]=0;
				if (!stralloc_cat(&pfilter_matches, &phrase->filename)) die_nomem();
				if (!stralloc_cats(&pfilter_matches, " (")) die_nomem();
				if (!stralloc_cats(&pfilter_matches, str)) die_nomem();
				if (!stralloc_cats(&pfilter_matches, " / ")) die_nomem();
				if (!stralloc_cats(&pfilter_matches, num)) die_nomem();
				if (!stralloc_cats(&pfilter_matches, ")<br>")) die_nomem();
				pfilter_current += *val;
				if (pfilter_current >= pfilter_max) {
					if (!stralloc_copy(&filter, &pfilter_matches)) die_nomem();
					filter.s[filter.len]=0;
					redir_site(REDIR_TYPE_CONT);
					return ACL_DENY;
				}
			}
		}
	}

	if (crfilter_host && crfilter_host->len)
	for (j=0; j < crfilter_host->len; j += str_len(crfilter_host->s+j)+1)
	list_for_each(l, &crfilter) {
		file = crfilter_host->s+j;
		regex = list_entry(l, struct squidwall_regex, list);
		if (str_equal(file, regex->filename.s))
		for (k=0; k < array_length(&regex->regex, sizeof(struct named_regex)); k++) {
			nr = array_get(&regex->regex, sizeof(struct named_regex), k);
			if (regexec(&nr->r, line, 0, 0, nr->eflags) == 0) {
				if (!stralloc_copy(&filter, &regex->filename)) die_nomem();
				if (!stralloc_cats(&filter, " / ")) die_nomem();
				if (!stralloc_cat(&filter, &nr->n)) die_nomem();
				filter.s[filter.len]=0;
				redir_site(REDIR_TYPE_CONT);
				return ACL_DENY;
			}
		}
	}

	if (crfilter_user && crfilter_user->len)
	for (j=0; j < crfilter_user->len; j += str_len(crfilter_user->s+j)+1)
	list_for_each(l, &crfilter) {
		file = crfilter_user->s+j;
		regex = list_entry(l, struct squidwall_regex, list);
		if (str_equal(file, regex->filename.s))
		for (k=0; k < array_length(&regex->regex, sizeof(struct named_regex)); k++) {
			nr = array_get(&regex->regex, sizeof(struct named_regex), k);
			if (regexec(&nr->r, line, 0, 0, nr->eflags) == 0) {
				if (!stralloc_copy(&filter, &regex->filename)) die_nomem();
				if (!stralloc_cats(&filter, " / ")) die_nomem();
				if (!stralloc_cat(&filter, &nr->n)) die_nomem();
				filter.s[filter.len]=0;
				redir_site(REDIR_TYPE_CONT);
				return ACL_DENY;
			}
		}
	}

	if (bcfilter_host && bcfilter_host->len)
	for (j=0; j < bcfilter_host->len; j += str_len(bcfilter_host->s+j)+1)
	list_for_each(l, &bcfilter) {
		file = bcfilter_host->s+j;
		regex = list_entry(l, struct squidwall_regex, list);
		if (str_equal(file, regex->filename.s))
		for (k=0; k < array_length(&regex->regex, sizeof(struct named_regex)); k++) {
			nr = array_get(&regex->regex, sizeof(struct named_regex), k);
			if (regexec(&nr->r, line, 0, 0, nr->eflags) == 0) {
				redir_site(REDIR_TYPE_BANNER);
				return ACL_DENY;
			}
		}
	}

	if (bcfilter_user && bcfilter_user->len)
	for (j=0; j < bcfilter_user->len; j += str_len(bcfilter_user->s+j)+1)
	list_for_each(l, &bcfilter) {
		file = bcfilter_user->s+j;
		regex = list_entry(l, struct squidwall_regex, list);
		if (str_equal(file, regex->filename.s))
		for (k=0; k < array_length(&regex->regex, sizeof(struct named_regex)); k++) {
			nr = array_get(&regex->regex, sizeof(struct named_regex), k);
			if (regexec(&nr->r, line, 0, 0, nr->eflags) == 0) {
				redir_site(REDIR_TYPE_BANNER);
				return ACL_DENY;
			}
		}
	}

	return ACL_ALLOW;
}

int check_cont(void)
{
	stralloc clamdtext;
	stralloc proxytext;
	stralloc content;
	int64 fd_clamd;  /* command connection to clamd */
	int64 fd_stream; /* our stream to clamav */
	int64 fd_proxy;  /* squid connection */
	size_t len=0;
	char ch;
	int i;

	if (!str_equal(squid_method, "GET"))
		return ACL_ALLOW;

	stralloc_init(&filter);
	stralloc_init(&content);
	stralloc_init(&clamdtext);
	stralloc_init(&proxytext);
	stralloc_init(&pfilter_matches);

	/* for closing all connections before returning */
	void close_connections(void)
	{
		buffer_flush(&clams_out);

		/* close all connections */
		clams_out.fd=-1; buffer_close(&clams_out); io_close(fd_stream);
		proxy_out.fd=-1; buffer_close(&proxy_out); io_close(fd_proxy);
		io_wantread(fd_clamd); io_wait(); io_dontwantread(fd_clamd);
		if (!stralloc_copys(&clamdtext, "")) die_nomem();
		while (buffer_getline_sa(&clamd_in, &clamdtext) != 0);
		clamd_out.fd=-1; buffer_close(&clamd_out); io_close(fd_clamd);

		/* free allocated space */
		stralloc_free(&content);
		stralloc_free(&clamdtext);
		stralloc_free(&proxytext);
		stralloc_free(&pfilter_matches);
	}

	/* connection to clamd */
	fd_clamd=socket_tcp4();
	if (fd_clamd == -1) return panic("socket() for clamd failed");
        i=socket_connect4(fd_clamd, (char*)&clamd_ip, clamd_port);
	if (i == -1) return panic("connect() to clamd failed");
	if (!io_fd(fd_clamd)) return panic("io_fd() failed");

	buffer_init(&clamd_in,   (int(*)())read, fd_clamd, clamd_iBUF, sizeof clamd_iBUF);
	buffer_init(&clamd_out, (int(*)())write, fd_clamd, clamd_oBUF, sizeof clamd_oBUF);

	io_wantwrite(fd_clamd); io_wait(); io_dontwantwrite(fd_clamd);
	buffer_putsflush(&clamd_out, "STREAM\n");

	io_wantread(fd_clamd); io_wait(); io_dontwantread(fd_clamd);
	if (buffer_getnewline_sa(&clamd_in, &clamdtext) == 0)
		return panic("can't read response of clamd");
	clamdtext.s[clamdtext.len]=0;
	if (!str_start(clamdtext.s, "PORT "))
		return panic("bad response from clamd, expected: PORT xxx");

	i=scan_uint(clamdtext.s+5, &clams_port);
	if (i == 0) panic("can't read port of clamd stream");

	/* open connection to clamd stream socket */
	fd_stream=socket_tcp4();
	if (fd_stream == -1) return panic("socket() for clamd failed");
        i=socket_connect4(fd_stream, (char*)&clamd_ip, clams_port);
	if (i == -1) return panic("connect() to clamd failed");
	buffer_init(&clams_out, (int(*)())write, fd_stream, clams_oBUF, sizeof clams_oBUF);
	if (!io_fd(fd_stream)) panic("io_fd() failed");

	/* open connection to proxy */
	fd_proxy=socket_tcp4();
	if (fd_stream == -1) return panic("socket() for proxy failed");
        i=socket_connect4(fd_proxy, (char*)&proxy_ip, proxy_port);
	if (i == -1) return panic("connect() to proxy failed");
	if (!io_fd(fd_proxy)) return panic("io_fd() failed");

	buffer_init(&proxy_in,   (int(*)())read, fd_proxy, proxy_iBUF, sizeof proxy_iBUF);
	buffer_init(&proxy_out, (int(*)())write, fd_proxy, proxy_oBUF, sizeof proxy_oBUF);

	/* send the request to squid */
	io_wantwrite(fd_proxy); io_wait(); io_dontwantwrite(fd_proxy);
	buffer_puts(&proxy_out, squid_method);
	buffer_puts(&proxy_out, " ");
	buffer_puts(&proxy_out, squid_url);
	buffer_putsflush(&proxy_out, " HTTP/1.0\r\n\r\n");

	/* look for bad content (if wanted) */
	cfilter_todo = SCAN_UNKNOWN;
	pfilter_todo = SCAN_UNKNOWN;
	pfilter_current = 0;
	while (buffer_get(&proxy_in, &ch, 1) == 1) {
		buffer_put(&clams_out, &ch, 1);
		if (++len >= maxsize) break;

		if (!stralloc_catb(&content, &ch, 1)) die_nomem();
		if (ch == '\n') { /* 'HTTP/1.0 200 OK\r\n' */
			if (content.len < 2) {
				if (!stralloc_copys(&content, "")) die_nomem();
				continue;
			}
			content.s[content.len-2]=0;

			if (cfilter_todo == SCAN_UNKNOWN) {
				cfilter_todo = check_cont_hdr(&array_cfilter_todo, content.s);
			}

			if (pfilter_todo == SCAN_UNKNOWN) {
				pfilter_todo = check_cont_hdr(&array_pfilter_todo, content.s);
			}

			if ((check_cont_line(content.s)) == ACL_DENY) {
				close_connections();
				return ACL_DENY;
			}

			if (!stralloc_copys(&content, "")) die_nomem();
		}
	}
	stralloc_free(&content);
	buffer_flush(&clams_out);

	/* close proxy and clamd stream connection */
	clams_out.fd=-1; buffer_close(&clams_out); io_close(fd_stream);
	proxy_out.fd=-1; buffer_close(&proxy_out); io_close(fd_proxy);
	stralloc_free(&proxytext);

	/* see, what clamd means to our stream */
	io_wantread(fd_clamd); io_wait(); io_dontwantread(fd_clamd);
	if (!stralloc_copys(&clamdtext, "")) die_nomem();
	while (buffer_getline_sa(&clamd_in, &clamdtext) != 0);
	
	/* close clamd connection */
	clamd_out.fd=-1; buffer_close(&clamd_out); io_close(fd_clamd);

	/* "stream: OK\n" -> if len==11 => no virus! */
	if (clamdtext.len <= 11) {
		stralloc_free(&clamdtext);
		return ACL_ALLOW;
	}

	/* "stream: ....\n" - but only 'FOUND' means there is a VIRUS! */
	clamdtext.s[clamdtext.len-1]=0;
	if (!str_equal(clamdtext.s+clamdtext.len-6, "FOUND")) {
		stralloc_free(&clamdtext);
		return ACL_ALLOW;
	}

	/* "stream: Worm.Sober.I FOUND\n" -> "Worm.Sober.I" */
	clamdtext.s[clamdtext.len-7]=0; /* remove " FOUND\n" */
	if (!stralloc_copys(&virus, clamdtext.s+8)) die_nomem();
	stralloc_free(&clamdtext);

	/* get curent version of clamav */
	fd_clamd=socket_tcp4();
	if (fd_clamd == -1) return panic("socket() for clamd failed");
	i=socket_connect4(fd_clamd, (char*)&clamd_ip, clamd_port);
	if (i == -1) return panic("connect() to clamd failed");
	if (!io_fd(fd_clamd)) return panic("io_fd() failed");

	buffer_init(&clamd_in, (int(*)())read, fd_clamd, clamd_iBUF,
		sizeof clamd_iBUF);
	buffer_init(&clamd_out, (int(*)())write, fd_clamd, clamd_oBUF,
		sizeof clamd_oBUF);

	io_wantwrite(fd_clamd); io_wait(); io_dontwantwrite(fd_clamd);
	buffer_putsflush(&clamd_out, "VERSION\n");
	io_wantread(fd_clamd); io_wait(); io_dontwantread(fd_clamd);
	if (buffer_getnewline_sa(&clamd_in, &clamav) == 0)
		return panic("can't read response of clamd");
	clamav.s[clamav.len]=0;
	if (!str_start(clamav.s, "ClamAV ")) {
		stralloc_free(&clamav);
		return panic("bad response from clamd, expected: 'ClamAV ' ...");
	}
	
	clamd_in.fd=-1;  buffer_close(&clamd_in);
	clamd_out.fd=-1; buffer_close(&clamd_out);
	io_close(fd_clamd);

	/* log the virus site */
	log_headline("virus");
	log_sa(&url);    log_s("\t");
	log_sa(&ip);     log_s("\t");
	log_sa(&host);   log_s("\t");
	log_sa(&user);   log_s("\t");
	log_sa(&method); log_s("\t");
	log_sa(&virus);  log_s("\n");
	redir_site(REDIR_TYPE_VIRUS);

	return ACL_DENY;
}
