#include "squidwall.h"

int check_host(void)
{
	struct list_head *l;
	struct squidwall_acl *acl;

	cfilter_host=pfilter_host=ufilter_host=crfilter_host=urfilter_host=0;
	bfilter_host=brfilter_host=wfilter_host=wrfilter_host=0;
	list_for_each(l, &hosts) {
		acl = list_entry(l, struct squidwall_acl, list);

		/* check ip */
		if (case_equals(acl->filename.s, ip.s)) {
			debug_s2(DEBUG_CHECK_HOST, "setze filter von ip ", ip.s);
			bfilter_host =&acl->bfilter;
			bcfilter_host=&acl->bcfilter;
			brfilter_host=&acl->brfilter;
			cfilter_host =&acl->cfilter;
			crfilter_host=&acl->crfilter;
			pfilter_host =&acl->pfilter;
			ufilter_host =&acl->ufilter;
			urfilter_host=&acl->urfilter;
			wfilter_host =&acl->wfilter;
			wrfilter_host=&acl->wrfilter;
			return acl->flags;
		}

		/* check hostname */
		if (case_equals(acl->filename.s, host.s)) {
			debug_s2(DEBUG_CHECK_HOST, "setze filter von host ", host.s);
			bfilter_host =&acl->bfilter;
			bcfilter_host=&acl->bcfilter;
			brfilter_host=&acl->brfilter;
			cfilter_host =&acl->cfilter;
			crfilter_host=&acl->crfilter;
			pfilter_host =&acl->pfilter;
			ufilter_host =&acl->ufilter;
			urfilter_host=&acl->urfilter;
			wfilter_host =&acl->wfilter;
			wrfilter_host=&acl->wrfilter;
			return acl->flags;
		}

	}

	return ACL_DEFAULT;
}
