#include "squidwall.h"

extern stralloc filter;

int check_url(void)
{
	struct squidwall_string *string;
	struct squidwall_regex *regex;
	struct named_regex *nr;
	struct list_head *l;
	int j, k;
	char *file, *str;

	stralloc_init(&filter);

	if (ufilter_host)
	for (j=0; j < ufilter_host->len; j += str_len(ufilter_host->s+j)+1)
	list_for_each(l, &ufilter) {
		string = list_entry(l, struct squidwall_string, list);
		file = ufilter_host->s+j;
		if (str_equal(file, string->filename.s))
		for (k=0; k < string->strings.len;
				k += str_len(string->strings.s+k)+1) {
			str = string->strings.s+k;
			if (case_strstr(squid_url, str)) {
				if(!stralloc_copy(&filter, &string->filename)) die_nomem();
				if(!stralloc_cats(&filter, " / ")) die_nomem();
				if(!stralloc_cats(&filter, str)) die_nomem();
				filter.s[filter.len]=0;
				return ACL_DENY;
			}
		}
	}

	if (ufilter_user)
	for (j=0; j < ufilter_user->len; j += str_len(ufilter_user->s+j)+1)
	list_for_each(l, &ufilter) {
		string = list_entry(l, struct squidwall_string, list);
		file = ufilter_user->s+j;
		if (str_equal(file, string->filename.s))
		for (k=0; k < string->strings.len;
				k += str_len(string->strings.s+k)+1) {
			str = string->strings.s+k;
			if (case_strstr(squid_url, str)) {
				if(!stralloc_copy(&filter, &string->filename)) die_nomem();
				if(!stralloc_cats(&filter, " / ")) die_nomem();
				if(!stralloc_cats(&filter, str)) die_nomem();
				filter.s[filter.len]=0;
				return ACL_DENY;
			}
		}
	}

	if (urfilter_host && urfilter_host->len)
	for (j=0; j < urfilter_host->len; j += str_len(urfilter_host->s+j)+1)
	list_for_each(l, &urfilter) {
		file = urfilter_host->s+j;
		regex = list_entry(l, struct squidwall_regex, list);
		if (str_equal(file, regex->filename.s))
		for (k=0; k < array_length(&regex->regex, sizeof(struct named_regex)); k++) {
			nr = array_get(&regex->regex, sizeof(struct named_regex), k);
			if (regexec(&nr->r, squid_url, 0, 0, nr->eflags) == 0) {
				if(!stralloc_copy(&filter, &regex->filename)) die_nomem();
				if(!stralloc_cats(&filter, " / ")) die_nomem();
				if(!stralloc_cat(&filter, &nr->n)) die_nomem();
				filter.s[filter.len]=0;
				return ACL_DENY;
			}
		}
	}

	if (urfilter_user && urfilter_user->len)
	for (j=0; j < urfilter_user->len; j += str_len(urfilter_user->s+j)+1)
	list_for_each(l, &urfilter) {
		file = urfilter_user->s+j;
		regex = list_entry(l, struct squidwall_regex, list);
		if (str_equal(file, regex->filename.s))
		for (k=0; k < array_length(&regex->regex, sizeof(regex_t)); k++) {
			nr = array_get(&regex->regex, sizeof(regex_t), k);
			if (regexec(&nr->r, squid_url, 0, 0, nr->eflags) == 0) {
				if(!stralloc_copy(&filter, &regex->filename)) die_nomem();
				if(!stralloc_cats(&filter, " / ")) die_nomem();
				if(!stralloc_cat(&filter, &nr->n)) die_nomem();
				filter.s[filter.len]=0;
				return ACL_DENY;
			}
		}
	}

	return ACL_ALLOW;
}
