#include "squidwall.h"

/* this function is called, when strange things happen :)
 *
 * 1. redirectors do never exit
 * 2. log only new messages
 */

static stralloc lastmsg;

int panic(char *msg)
{
	static int firstcall=1;
	
	if (firstcall) {
		stralloc_init(&lastmsg);
		firstcall=0;
	} else {
		/* look, if the msg is exact the last one */
		if (str_equal(msg, lastmsg.s)) return ACL_DEFAULT;
	}

	log_headline("panic"); log_s(msg); log_s("\n");
	log_flush();

	if (!stralloc_copys(&lastmsg, msg)) die_nomem();

	return ACL_DEFAULT;
}
