#ifndef SW_PRAMS_H
#define SW_PRAMS_H

/*
 * all these values can be overridden by environment variables!
 */
#define VERSION    "squidwall 0.3a"

#define BUFSIZE    5000

/* this logfile will show you the denied users/hosts/pages */
#define LOG_FILE         "/var/log/squid/squidwall.log"

/* ip:port of your squid cache
 *
 * warning: this cache should not re-redirect to the redirector :)
 */
#define PROXY            "127.0.0.1:3128"

/* ip:port of clamd in TCP/IP mode */
#define CLAMD            "127.0.0.1:3310"

/* the default size in bytes, which will be passed through the content
 * filter and the clamav stream for antivirus checking
 */
#define MAX_SIZE         60000

/* phrase filter */
#define PFILTER_MAX      100 /* deadline for the pfilters, variable from 0..255 */
#define PFILTER_DEFAULT  25 /* for unacceptable values in configuration */

/* user/host acl's */
#define HOSTS_DIR        "/etc/squidwall/hosts"
#define USERS_DIR        "/etc/squidwall/users"

/* content filters */
#define PFILTERS_DIR     "/etc/squidwall/filters/pfilter"
#define CFILTERS_DIR     "/etc/squidwall/filters/cfilter"
#define CRFILTERS_DIR    "/etc/squidwall/filters/crfilter"
#define BCFILTERS_DIR    "/etc/squidwall/filters/bcfilter"

/* url filters */
#define BFILTERS_DIR     "/etc/squidwall/filters/bfilter"
#define BRFILTERS_DIR    "/etc/squidwall/filters/brfilter"
#define UFILTERS_DIR     "/etc/squidwall/filters/ufilter"
#define URFILTERS_DIR    "/etc/squidwall/filters/urfilter"
#define WFILTERS_DIR     "/etc/squidwall/filters/wfilter"
#define WRFILTERS_DIR    "/etc/squidwall/filters/wrfilter"

/* url forbidden */
#define REDIR_BADURL     "http://www.example.org/?network=x&reason=url&"

/* forbidden content */
#define REDIR_BADCONT    "http://www.example.org/?network=x&reason=cont&"

/* host/ip forbidden */
#define REDIR_BADHOST    "http://www.example.org/?network=x&reason=host&"

/* user forbidden */
#define REDIR_BADUSER    "http://www.example.org/?network=x&reason=user&"

/* if a virus is found, the user will be redirected to this page */
#define REDIR_VIRUSFOUND "http://www.example.org/?network=x&reason=virus&"

/* if a banner-url is found, the user will be redirected to this image */
#define REDIR_BANNERFOUND "http://www.example.org/img/t.png"

/* this url nerver redirected! */
#define REDIR_SAFESITE   "http://www.example.org/"

/* if unneeded, define it to zero */
#define WANT_STARTUP_INFO 1

/* debugging of some functions / files */
#define DEBUG_SQUIDWALL      1
#define DEBUG_READ_ACLS      2
#define DEBUG_READ_FILTERS   4
#define DEBUG_CHECK_HOST     8
#define DEBUG_CHECK_USER    16
#define DEBUG_CHECK_BANNER  32
#define DEBUG_CHECK_WLIST   64
#define DEBUG_CHECK_URL    128
#define DEBUG_CHECK_CONT   256

#define DEBUG_ALL         (1|2|4|16|32|64|128|256)
//#define DEBUG_LEVEL       (DEBUG_SQUIDWALL|DEBUG_READ_ACLS|DEBUG_CHECK_USER|DEBUG_CHECK_HOST|DEBUG_CHECK_CONT)
#define DEBUG_LEVEL 0

#endif
