<?

/* Webinterface for squidwall
 *
 * ctime: 2005-06-29
 * mtime: 2005-12-08
 *
 * Beschreibung:
 * 1. Authentifizierung
 * 2. Funktionen definieren
 * 3. Datenbanken prfen und einlesen
 */

header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");
header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT");
header("Cache-Control: no-store, no-cache, must-revalidate");
header("Cache-Control: post-check=0, pre-check=0", false);
header("Cache-Control: private" );
header("Pragma: no-cache");

/* Funktion zum Beenden einer Anfrage */
function print_foot() {
 echo "</body></html>";
 exit;
}

include("$P_INT/lang.php"); /* Sprachen */
include("$P_INT/auth.php"); /* Benutzerprfung */

function fatal_error($a="") {
 global $P_INT;
 include("$P_INT/HEAD");
 echo $a;
 print_foot();
}

/* for my_edit_hosts() */
function my_rename($dir, $file, $pold, $pnew) {
 global $changed;
// echo "my_rename(): von '$dir./.$pold.$file' nach '$dir./.$pnew.$file'<br>";
 rename($dir."/"."$pold$file", $dir."/"."$pnew$file");
 $changed=1;
 return;
}

/* for my_edit_hosts() */
function my_touch($dir, $file, $p) {
 global $changed;
// echo "my_touch(): '$dir./.$p.$file'<br>";
 touch($dir."/"."$p$file");
 $changed=1;
 return;
}

/* touches, renames files as wanted */
function my_edit_acls($dir2save, $filename) {
 global $changed, $group;

 $f=file($filename);
 $sel_access_prefix = array ("+", "?", "-");

 for($i=0; isset($f[$i]); $i++) {
  $e=chop($f[$i]);
  $x=$_POST["$group$i"];    /* die zahl: 1..3 -> 0..2 */
  $c=$sel_access_prefix[$x-1]; /* '+' '?' '-' */
  $changed=0;

  switch ($c) {
  case "+":
   if (is_file($dir2save . "/?" . $e)) { my_rename($dir2save, "$e", "?", "+"); break; }
   if (is_file($dir2save . "/-" . $e)) { my_rename($dir2save, "$e", "-", "+"); break; }
   if (!is_file($dir2save . "/+" . $e)) { my_touch($dir2save, "$e", "+"); }
   break;
  case "?":
   if (is_file($dir2save . "/+" . $e)) { my_rename($dir2save, "$e", "+", "?"); break; }
   if (is_file($dir2save . "/-" . $e)) { my_rename($dir2save, "$e", "-", "?"); break; }
   if (!is_file($dir2save . "/?" . $e)) { my_touch($dir2save, "$e", "?"); }
   break;
  case "-":
   if (is_file($dir2save . "/?" . $e)) { my_rename($dir2save, "$e", "?", "-"); break; }
   if (is_file($dir2save . "/+" . $e)) { my_rename($dir2save, "$e", "+", "-"); break; }
   if (!is_file($dir2save . "/-" . $e)) { my_touch($dir2save, "$e", "-"); }
   break;
  default:
   break;
  }

  /* die Datei '!' wird durch squidwall geprft */
  if ($changed == 1) { touch("$dir2save/!"); }
 }
}

/* touches, renames files as wanted */
function my_edit_filters($filename) {
 $defs = $_POST['defs'];
 $defs = str_replace("\r\n", "\n", $defs);
 $defs = str_replace("\"", '"', $defs);
 $defs = str_replace("\\", "", $defs);
 $f=fopen("$filename","w");
 fwrite($f, $defs, strlen($defs));
 fclose($f);
 $f = dirname($filename) . "/!";
 touch($f);
}

/* diverse Verzeichnisse prfen */
if (!is_dir($P_USERS)) { fatal_error("Can't read user definitions !"); }
if (!is_dir($P_HOSTS)) { fatal_error("Can't read host definitions !"); }

/* datenbanken raussuchen */
$dh=opendir("$P_INT/hosts");
while ($file = readdir($dh)) {
 if (!is_file("$P_INT/hosts/$file")) { continue; }
 $H[] = $file;
}
closedir($dh);
sort($H); reset($H);

if (count($H) < 1) {
 $h=count($H); fatal_error("Not enough hosts defined!");
}

$dh=opendir("$P_INT/users");
while ($file = readdir($dh)) {
 if (!is_file("$P_INT/users/$file")) { continue; }
 $U[] = $file;
}
closedir($dh);
sort($U); reset($U);

if (count($U) < 1) {
 $u=count($U); fatal_error("Not enough users defined!");
}

$dh=opendir("$P_BFILTER");
while ($file = readdir($dh)) {
 if (!is_file("$P_BFILTER/$file")) { continue; }
 if ($file == "!" || $file == "@" || $file == "README") { continue; }
 $BF[] = $file;
}
closedir($dh);
if (count($BF)) { sort($BF); reset($BF); }

$dh=opendir("$P_BCFILTER");
while ($file = readdir($dh)) {
 if (!is_file("$P_BCFILTER/$file")) { continue; }
 if ($file == "!" || $file == "@" || $file == "README") { continue; }
 $BCF[] = $file;
}
closedir($dh);
if (count($BCF)) { sort($BCF); reset($BCF); }

$dh=opendir("$P_BRFILTER");
while ($file = readdir($dh)) {
 if (!is_file("$P_BRFILTER/$file")) { continue; }
 if ($file == "!" || $file == "@" || $file == "README") { continue; }
 $BRF[] = $file;
}
closedir($dh);
if (count($BRF)) { sort($BRF); reset($BRF); }

$dh=opendir("$P_PFILTER");
while ($file = readdir($dh)) {
 if (!is_file("$P_PFILTER/$file")) { continue; }
 if ($file == "!" || $file == "@" || $file == "README") { continue; }
 $PF[] = $file;
}
closedir($dh);

$dh=opendir("$P_CFILTER");
while ($file = readdir($dh)) {
 if (!is_file("$P_CFILTER/$file")) { continue; }
 if ($file == "!" || $file == "@" || $file == "README") { continue; }
 $CF[] = $file;
}
closedir($dh);
if (count($CF)) { sort($CF); reset($CF); }

$dh=opendir("$P_CRFILTER");
while ($file = readdir($dh)) {
 if (!is_file("$P_CRFILTER/$file")) { continue; }
 if ($file == "!" || $file == "@" || $file == "README") { continue; }
 $CRF[] = $file;
}
closedir($dh);
if (count($CRF)) { sort($CRF); reset($CRF); }

if (count($PF)) { sort($PF); reset($PF); }
$dh=opendir("$P_UFILTER");
while ($file = readdir($dh)) {
 if (!is_file("$P_UFILTER/$file")) { continue; }
 if ($file == "!" || $file == "@" || $file == "README") { continue; }
 $UF[] = $file;
}
closedir($dh);
if (count($UF)) { sort($UF); reset($UF); }

$dh=opendir("$P_URFILTER");
while ($file = readdir($dh)) {
 if (!is_file("$P_URFILTER/$file")) { continue; }
 if ($file == "!" || $file == "@" || $file == "README") { continue; }
 $URF[] = $file;
}
closedir($dh);
if (count($URF)) { sort($URF); reset($URF); }

if (count($WF)) { sort($WF); reset($WF); }
$dh=opendir("$P_WFILTER");
while ($file = readdir($dh)) {
 if (!is_file("$P_WFILTER/$file")) { continue; }
 if ($file == "!" || $file == "@" || $file == "README") { continue; }
 $WF[] = $file;
}
closedir($dh);
if (count($WF)) { sort($WF); reset($WF); }

$dh=opendir("$P_WRFILTER");
while ($file = readdir($dh)) {
 if (!is_file("$P_WRFILTER/$file")) { continue; }
 if ($file == "!" || $file == "@" || $file == "README") { continue; }
 $WRF[] = $file;
}
closedir($dh);
if (count($WRF)) { sort($WRF); reset($WRF); }

?>
